//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  }EXJ[\̃Rg[}EXzC[ɂXN[\
//  tH[TScrollBoxTListBox,TListViewzuĂꍇ
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2018N0324 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Panel1: TPanel;
    ListView1: TListView;
    procedure FormCreate(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  LCount : Integer;
  LIndex : Integer;
  LText  : string;
begin
  //TListViewɃeXgp̃f[^Zbg
  LCount := 50;

  ListView1.ViewStyle := vsReport;
  ListView1.Columns.Add;
  ListView1.Column[0].Width   := -1;
  ListView1.Column[0].Caption := '';

  ListView1.Font.Name := 'Courier New';
  ListView1.Font.Size := 9;

  ListView1.Items.BeginUpdate;
  for LIndex := 0 to LCount - 1 do begin
    LText := 'ITem-' + Format('%.3d', [LIndex + 1]);
    ListView1.Items.Add.Caption := LText;
  end;
  ListView1.Items.EndUpdate;


  //TScrollBox̃XN[Wݒ
  ScrollBox1.HorzScrollBar.Range := Panel1.Width + 50;
  ScrollBox1.VertScrollBar.Range := Panel1.Height + 50;

  //TScrollBox̃XN[̃gbLOݒ
  ScrollBox1.HorzScrollBar.Tracking := True;
  ScrollBox1.VertScrollBar.Tracking := True;
end;

//=============================================================================
//  eł邱̃tH[OnMouseWheelCxg
//=============================================================================
procedure TForm1.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  LWinCtrl : TWinControl;
  LCurPos  : TPoint;
  LDelta   : Integer;
begin
  LWinCtrl := FindVCLWindow(MousePos);


  //TListBox,TListView̏ꍇ
  if (LWinCtrl is TListBox) or (LWinCtrl is TListView) then begin
    if WheelDelta > 0 then begin
      LWinCtrl.Perform(WM_VSCROLL, SB_LINEUP, 0);
    end else begin
      LWinCtrl.Perform(WM_VSCROLL, SB_LINEDOWN, 0);
    end;
  end else begin
    //}EXJ[\ʒuScrollBox1̃NCAg̈̎
    LCurPos := ScrollBox1.ScreenToClient(MousePos);

    if PtInRect(ScrollBox1.ClientRect, LCurPos) then begin
      LDelta := WheelDelta div 5;
      if ssCtrl in Shift then begin
        ScrollBox1.HorzScrollBar.Position := ScrollBox1.HorzScrollBar.Position - LDelta;
      end else begin
        ScrollBox1.VertScrollBar.Position := ScrollBox1.VertScrollBar.Position - LDelta;
      end;
    end;
  end;

  Handled := True;
end;

end.
